/* ChannelGroup.c generated by valac 0.12.0, the Vala compiler
 * generated from ChannelGroup.vala, do not modify */

/*
 * Copyright (C) 2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define DVB_TYPE_CHANNEL_GROUP (dvb_channel_group_get_type ())
#define DVB_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroup))
#define DVB_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))
#define DVB_IS_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_GROUP))
#define DVB_IS_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_GROUP))
#define DVB_CHANNEL_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))

typedef struct _DVBChannelGroup DVBChannelGroup;
typedef struct _DVBChannelGroupClass DVBChannelGroupClass;
typedef struct _DVBChannelGroupPrivate DVBChannelGroupPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DVBChannelGroup {
	GObject parent_instance;
	DVBChannelGroupPrivate * priv;
};

struct _DVBChannelGroupClass {
	GObjectClass parent_class;
};

struct _DVBChannelGroupPrivate {
	gint _id;
	gchar* _name;
};


static gpointer dvb_channel_group_parent_class = NULL;

GType dvb_channel_group_get_type (void) G_GNUC_CONST;
#define DVB_CHANNEL_GROUP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupPrivate))
enum  {
	DVB_CHANNEL_GROUP_DUMMY_PROPERTY,
	DVB_CHANNEL_GROUP_ID,
	DVB_CHANNEL_GROUP_NAME
};
DVBChannelGroup* dvb_channel_group_new (gint id, const gchar* name);
DVBChannelGroup* dvb_channel_group_construct (GType object_type, gint id, const gchar* name);
void dvb_channel_group_set_id (DVBChannelGroup* self, gint value);
void dvb_channel_group_set_name (DVBChannelGroup* self, const gchar* value);
gint dvb_channel_group_get_id (DVBChannelGroup* self);
const gchar* dvb_channel_group_get_name (DVBChannelGroup* self);
static void dvb_channel_group_finalize (GObject* obj);
static void _vala_dvb_channel_group_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dvb_channel_group_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


DVBChannelGroup* dvb_channel_group_construct (GType object_type, gint id, const gchar* name) {
	DVBChannelGroup * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (DVBChannelGroup*) g_object_new (object_type, NULL);
	dvb_channel_group_set_id (self, id);
	dvb_channel_group_set_name (self, name);
	return self;
}


DVBChannelGroup* dvb_channel_group_new (gint id, const gchar* name) {
	return dvb_channel_group_construct (DVB_TYPE_CHANNEL_GROUP, id, name);
}


gint dvb_channel_group_get_id (DVBChannelGroup* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_id;
	return result;
}


void dvb_channel_group_set_id (DVBChannelGroup* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_id = value;
	g_object_notify ((GObject *) self, "id");
}


const gchar* dvb_channel_group_get_name (DVBChannelGroup* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_name;
	return result;
}


void dvb_channel_group_set_name (DVBChannelGroup* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp0_;
	g_object_notify ((GObject *) self, "name");
}


static void dvb_channel_group_class_init (DVBChannelGroupClass * klass) {
	dvb_channel_group_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DVBChannelGroupPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_channel_group_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_channel_group_set_property;
	G_OBJECT_CLASS (klass)->finalize = dvb_channel_group_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_CHANNEL_GROUP_ID, g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_CHANNEL_GROUP_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void dvb_channel_group_instance_init (DVBChannelGroup * self) {
	self->priv = DVB_CHANNEL_GROUP_GET_PRIVATE (self);
}


static void dvb_channel_group_finalize (GObject* obj) {
	DVBChannelGroup * self;
	self = DVB_CHANNEL_GROUP (obj);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (dvb_channel_group_parent_class)->finalize (obj);
}


GType dvb_channel_group_get_type (void) {
	static volatile gsize dvb_channel_group_type_id__volatile = 0;
	if (g_once_init_enter (&dvb_channel_group_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DVBChannelGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_channel_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBChannelGroup), 0, (GInstanceInitFunc) dvb_channel_group_instance_init, NULL };
		GType dvb_channel_group_type_id;
		dvb_channel_group_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBChannelGroup", &g_define_type_info, 0);
		g_once_init_leave (&dvb_channel_group_type_id__volatile, dvb_channel_group_type_id);
	}
	return dvb_channel_group_type_id__volatile;
}


static void _vala_dvb_channel_group_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DVBChannelGroup * self;
	self = DVB_CHANNEL_GROUP (object);
	switch (property_id) {
		case DVB_CHANNEL_GROUP_ID:
		g_value_set_int (value, dvb_channel_group_get_id (self));
		break;
		case DVB_CHANNEL_GROUP_NAME:
		g_value_set_string (value, dvb_channel_group_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_dvb_channel_group_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DVBChannelGroup * self;
	self = DVB_CHANNEL_GROUP (object);
	switch (property_id) {
		case DVB_CHANNEL_GROUP_ID:
		dvb_channel_group_set_id (self, g_value_get_int (value));
		break;
		case DVB_CHANNEL_GROUP_NAME:
		dvb_channel_group_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



