/* MediaMapping.c generated by valac 0.12.0, the Vala compiler
 * generated from MediaMapping.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gst/rtsp-server/rtsp-media-mapping.h>
#include <gst/rtsp-server/rtsp-media-factory.h>
#include <gst/rtsp/gstrtspconnection.h>


#define DVB_TYPE_MEDIA_MAPPING (dvb_media_mapping_get_type ())
#define DVB_MEDIA_MAPPING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_MEDIA_MAPPING, DVBMediaMapping))
#define DVB_MEDIA_MAPPING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_MEDIA_MAPPING, DVBMediaMappingClass))
#define DVB_IS_MEDIA_MAPPING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_MEDIA_MAPPING))
#define DVB_IS_MEDIA_MAPPING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_MEDIA_MAPPING))
#define DVB_MEDIA_MAPPING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_MEDIA_MAPPING, DVBMediaMappingClass))

typedef struct _DVBMediaMapping DVBMediaMapping;
typedef struct _DVBMediaMappingClass DVBMediaMappingClass;
typedef struct _DVBMediaMappingPrivate DVBMediaMappingPrivate;

#define DVB_TYPE_MEDIA_FACTORY (dvb_media_factory_get_type ())
#define DVB_MEDIA_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_MEDIA_FACTORY, DVBMediaFactory))
#define DVB_MEDIA_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_MEDIA_FACTORY, DVBMediaFactoryClass))
#define DVB_IS_MEDIA_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_MEDIA_FACTORY))
#define DVB_IS_MEDIA_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_MEDIA_FACTORY))
#define DVB_MEDIA_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_MEDIA_FACTORY, DVBMediaFactoryClass))

typedef struct _DVBMediaFactory DVBMediaFactory;
typedef struct _DVBMediaFactoryClass DVBMediaFactoryClass;

struct _DVBMediaMapping {
	GstRTSPMediaMapping parent_instance;
	DVBMediaMappingPrivate * priv;
};

struct _DVBMediaMappingClass {
	GstRTSPMediaMappingClass parent_class;
};


static gpointer dvb_media_mapping_parent_class = NULL;
static GstRTSPMediaFactory* dvb_media_mapping_factory_instance;
static GstRTSPMediaFactory* dvb_media_mapping_factory_instance = NULL;

GType dvb_media_mapping_get_type (void) G_GNUC_CONST;
enum  {
	DVB_MEDIA_MAPPING_DUMMY_PROPERTY
};
DVBMediaFactory* dvb_media_factory_new (void);
DVBMediaFactory* dvb_media_factory_construct (GType object_type);
GType dvb_media_factory_get_type (void) G_GNUC_CONST;
static GstRTSPMediaFactory* dvb_media_mapping_real_find_media (GstRTSPMediaMapping* base, GstRTSPUrl* url);
DVBMediaMapping* dvb_media_mapping_new (void);
DVBMediaMapping* dvb_media_mapping_construct (GType object_type);
static void dvb_media_mapping_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GstRTSPMediaFactory* dvb_media_mapping_real_find_media (GstRTSPMediaMapping* base, GstRTSPUrl* url) {
	DVBMediaMapping * self;
	GstRTSPMediaFactory* result = NULL;
	GstRTSPMediaFactory* _tmp0_;
	self = (DVBMediaMapping*) base;
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = _g_object_ref0 (dvb_media_mapping_factory_instance);
	result = _tmp0_;
	return result;
}


DVBMediaMapping* dvb_media_mapping_construct (GType object_type) {
	DVBMediaMapping * self = NULL;
	self = (DVBMediaMapping*) g_object_new (object_type, NULL);
	return self;
}


DVBMediaMapping* dvb_media_mapping_new (void) {
	return dvb_media_mapping_construct (DVB_TYPE_MEDIA_MAPPING);
}


static void dvb_media_mapping_class_init (DVBMediaMappingClass * klass) {
	DVBMediaFactory* _tmp0_ = NULL;
	dvb_media_mapping_parent_class = g_type_class_peek_parent (klass);
	GST_RTSP_MEDIA_MAPPING_CLASS (klass)->find_media = dvb_media_mapping_real_find_media;
	G_OBJECT_CLASS (klass)->finalize = dvb_media_mapping_finalize;
	_tmp0_ = dvb_media_factory_new ();
	dvb_media_mapping_factory_instance = (GstRTSPMediaFactory*) _tmp0_;
}


static void dvb_media_mapping_instance_init (DVBMediaMapping * self) {
}


static void dvb_media_mapping_finalize (GObject* obj) {
	DVBMediaMapping * self;
	self = DVB_MEDIA_MAPPING (obj);
	G_OBJECT_CLASS (dvb_media_mapping_parent_class)->finalize (obj);
}


GType dvb_media_mapping_get_type (void) {
	static volatile gsize dvb_media_mapping_type_id__volatile = 0;
	if (g_once_init_enter (&dvb_media_mapping_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DVBMediaMappingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_media_mapping_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBMediaMapping), 0, (GInstanceInitFunc) dvb_media_mapping_instance_init, NULL };
		GType dvb_media_mapping_type_id;
		dvb_media_mapping_type_id = g_type_register_static (GST_TYPE_RTSP_MEDIA_MAPPING, "DVBMediaMapping", &g_define_type_info, 0);
		g_once_init_leave (&dvb_media_mapping_type_id__volatile, dvb_media_mapping_type_id);
	}
	return dvb_media_mapping_type_id__volatile;
}



